function stimSetCellStr = getStimSetCellStr(stimSetInd)
% Generate all stimulus names used in a particular experiment.
switch stimSetInd
    case 1 % (old)ONOFF+Bars
        stimSetCellStr = ...
        {'LocalCircle_ONOFF_2s_BG_4s_120deg_0degAz_0degEl_100_Con_0.5Lum_NonRand.txt', ...
         'StandingStripe_1s_XAxis_5degWide_2degSep_m1.0Con_rand_USEFRUSTUM.txt', ...
         'StandingStripe_1s_YAxis_5degWide_2degSep_m1.0Con_rand_USEFRUSTUM.txt', ...
         'StandingStripe_1s_XAxis_5degWide_2degSep_p1.0Con_rand_USEFRUSTUM.txt', ...
         'StandingStripe_1s_YAxis_5degWide_2degSep_p1.0Con_rand_USEFRUSTUM.txt'};
    case 2 % ONOFF+Bars
        stimSetCellStr = ...
        {'FullField_ONOFF_1.0_2s_BG_0.5_4s_Weber_NonRand.txt', ...   
         'StandingStripe_1s_XAxis_5degWide_2degSep_m1.0Con_rand_USEFRUSTUM.txt', ...
         'StandingStripe_1s_YAxis_5degWide_2degSep_m1.0Con_rand_USEFRUSTUM.txt', ...
         'StandingStripe_1s_XAxis_5degWide_2degSep_p1.0Con_rand_USEFRUSTUM.txt', ...
         'StandingStripe_1s_YAxis_5degWide_2degSep_p1.0Con_rand_USEFRUSTUM.txt'};
    case 3 % ONOFF+Bars+Noise
        stimSetCellStr = ...
        {'FullField_ONOFF_1.0_2s_BG_0.5_4s_Weber_NonRand.txt'                  , ...           
         'StandingStripe_1s_XAxis_5degWide_2degSep_m1.0Con_rand_USEFRUSTUM.txt', ...
         'StandingStripe_1s_YAxis_5degWide_2degSep_m1.0Con_rand_USEFRUSTUM.txt', ...
         'StandingStripe_1s_XAxis_5degWide_2degSep_p1.0Con_rand_USEFRUSTUM.txt', ...
         'StandingStripe_1s_YAxis_5degWide_2degSep_p1.0Con_rand_USEFRUSTUM.txt', ...
         'StimulusData_Discrete_1_1_100000_Seed_735723_50ms.txt'               , ...
         'StimulusData_Discrete_1_12_100000_Seed_735723_Az_100ms.txt'          , ...
         'StimulusData_Discrete_1_12_100000_Seed_735723_El_100ms.txt'          }; 
    case 4 % ONOFF+Bars+Edges+Sines
        stimSetCellStr = ...
        {'FullField_ONOFF_1.0_2s_BG_0.5_4s_Weber_NonRand.txt', ...   
         'StandingStripe_1s_XAxis_5degWide_2degSep_m1.0Con_rand_USEFRUSTUM.txt', ...
         'StandingStripe_1s_YAxis_5degWide_2degSep_m1.0Con_rand_USEFRUSTUM.txt', ...
         'StandingStripe_1s_XAxis_5degWide_2degSep_p1.0Con_rand_USEFRUSTUM.txt', ...
         'StandingStripe_1s_YAxis_5degWide_2degSep_p1.0Con_rand_USEFRUSTUM.txt', ...
        'DriftingEdge_LumDecLumInc_1period_20degPerSec_90deg_BlankRand_4Dirs.txt', ...
        'DriftingSineGrating_4s_BG_4s_0p25-16Hz_2-32deg_BlankRand_1Dir_90deg.txt'};   
            
end